Index: XIOS/dev/branch_openmp/extern/remap/src/mpi_routing.cpp
===================================================================
--- XIOS/dev/branch_openmp/extern/remap/src/mpi_routing.cpp	(revision 1545)
+++ XIOS/dev/branch_openmp/extern/remap/src/mpi_routing.cpp	(revision 1642)
@@ -5,5 +5,4 @@
 #include "timerRemap.hpp"
 #include <iostream>
-using namespace ep_lib;
 
 namespace sphereRemap {
@@ -11,8 +10,8 @@
 const int verbose = 0;
 
-CMPIRouting::CMPIRouting(MPI_Comm comm) : communicator(comm)
-{
-	MPI_Comm_rank(comm, &mpiRank);
-	MPI_Comm_size(comm, &mpiSize);
+CMPIRouting::CMPIRouting(ep_lib::MPI_Comm comm) : communicator(comm)
+{
+	ep_lib::MPI_Comm_rank(comm, &mpiRank);
+	ep_lib::MPI_Comm_size(comm, &mpiSize);
 }
 
@@ -20,8 +19,8 @@
     but message lengths are *known* to receiver */
 template <typename T>
-void alltoalls_known(const vector<vector<T> >& send, vector<vector<T> >& recv, const vector<int>& ranks, MPI_Comm communicator)
-{
-	vector<MPI_Request> request(ranks.size() * 2);
-	vector<MPI_Status>  status(ranks.size() * 2);
+void alltoalls_known(const vector<vector<T> >& send, vector<vector<T> >& recv, const vector<int>& ranks, ep_lib::MPI_Comm communicator)
+{
+	vector<ep_lib::MPI_Request> request(ranks.size() * 2);
+	vector<ep_lib::MPI_Status>  status(ranks.size() * 2);
 
 	// communicate data
@@ -29,9 +28,9 @@
 	for (int i = 0; i < ranks.size(); i++)
 		if (recv[i].size())
-			MPI_Irecv(&recv[i][0], recv[i].size()*sizeof(T), MPI_CHAR, ranks[i], 0, communicator, &request[nbRequest++]);
+			ep_lib::MPI_Irecv(&recv[i][0], recv[i].size()*sizeof(T), EP_CHAR, ranks[i], 0, communicator, &request[nbRequest++]);
 	for (int i = 0; i < ranks.size(); i++)
 		if (send[i].size())
-			MPI_Isend((void *) &send[i][0], send[i].size()*sizeof(T), MPI_CHAR, ranks[i], 0, communicator, &request[nbRequest++]);
-	MPI_Waitall(nbRequest, &request[0], &status[0]);
+			ep_lib::MPI_Isend((void *) &send[i][0], send[i].size()*sizeof(T), EP_CHAR, ranks[i], 0, communicator, &request[nbRequest++]);
+	ep_lib::MPI_Waitall(nbRequest, &request[0], &status[0]);
 }
 
@@ -39,8 +38,8 @@
     but message lengths are *unknown* to receiver */
 template <typename T>
-void alltoalls_unknown(const vector<vector<T> >& send, vector<vector<T> >& recv, const vector<int>& ranks, MPI_Comm communicator)
-{
-	vector<MPI_Request> request(ranks.size() * 2);
-	vector<MPI_Status>  status(ranks.size() * 2);
+void alltoalls_unknown(const vector<vector<T> >& send, vector<vector<T> >& recv, const vector<int>& ranks, ep_lib::MPI_Comm communicator)
+{
+	vector<ep_lib::MPI_Request> request(ranks.size() * 2);
+	vector<ep_lib::MPI_Status>  status(ranks.size() * 2);
 
 	// communicate sizes
@@ -51,8 +50,8 @@
 		sendSizes[i] = send[i].size();
 	for (int i = 0; i < ranks.size(); i++)
-		MPI_Irecv(&recvSizes[i], 1, MPI_INT, ranks[i], 0, communicator, &request[nbRequest++]);
+		ep_lib::MPI_Irecv(&recvSizes[i], 1, EP_INT, ranks[i], 0, communicator, &request[nbRequest++]);
 	for (int i = 0; i < ranks.size(); i++)
-		MPI_Isend(&sendSizes[i], 1, MPI_INT, ranks[i], 0, communicator, &request[nbRequest++]);
-	MPI_Waitall(nbRequest, &request[0], &status[0]);
+		ep_lib::MPI_Isend(&sendSizes[i], 1, EP_INT, ranks[i], 0, communicator, &request[nbRequest++]);
+	ep_lib::MPI_Waitall(nbRequest, &request[0], &status[0]);
 
 	// allocate
@@ -119,10 +118,10 @@
 	CTimer::get("CMPIRouting::init(reduce_scatter)").reset();
 	CTimer::get("CMPIRouting::init(reduce_scatter)").resume();
-	MPI_Reduce_scatter(toSend, &nbSource, recvCount, MPI_INT, MPI_SUM, communicator);
+	ep_lib::MPI_Reduce_scatter(toSend, &nbSource, recvCount, EP_INT, EP_SUM, communicator);
 	CTimer::get("CMPIRouting::init(reduce_scatter)").suspend();
 	CTimer::get("CMPIRouting::init(reduce_scatter)").print();
 
-	MPI_Alloc_mem(nbTarget *sizeof(int), MPI_INFO_NULL, &targetRank);
-	MPI_Alloc_mem(nbSource *sizeof(int), MPI_INFO_NULL, &sourceRank);
+	ep_lib::MPI_Alloc_mem(nbTarget *sizeof(int), EP_INFO_NULL, &targetRank);
+	ep_lib::MPI_Alloc_mem(nbSource *sizeof(int), EP_INFO_NULL, &sourceRank);
 
 	targetRankToIndex = new int[mpiSize];
@@ -138,10 +137,10 @@
 	}
 
-	MPI_Barrier(communicator);
+	ep_lib::MPI_Barrier(communicator);
 	CTimer::get("CMPIRouting::init(get_source)").reset();
 	CTimer::get("CMPIRouting::init(get_source)").resume();
 
-	MPI_Request *request = new MPI_Request[nbSource + nbTarget];
-	MPI_Status  *status = new MPI_Status[nbSource + nbTarget];
+	ep_lib::MPI_Request *request = new ep_lib::MPI_Request[nbSource + nbTarget];
+	ep_lib::MPI_Status  *status = new ep_lib::MPI_Status[nbSource + nbTarget];
 
 	int indexRequest = 0;
@@ -151,14 +150,16 @@
 	for (int i = 0; i < nbSource; i++)
 	{
-		#ifdef _usingEP
-		MPI_Irecv(&sourceRank[i], 1, MPI_INT, -2, 0, communicator, &request[indexRequest++]);
-		#else
-		MPI_Irecv(&sourceRank[i], 1, MPI_INT, MPI_ANY_SOURCE, 0, communicator, &request[indexRequest++]);
+		#ifdef _usingMPI
+                ep_lib::MPI_Irecv(&sourceRank[i], 1, EP_INT, MPI_ANY_SOURCE, 0, communicator, &request[indexRequest]);
+		#elif _usingEP
+                ep_lib::MPI_Irecv(&sourceRank[i], 1, EP_INT, -2, 0, communicator, &request[indexRequest]);
 		#endif
+                indexRequest++;
 	}
 	MPI_Barrier(communicator);
 	for (int i = 0; i < nbTarget; i++)
 	{
-		MPI_Isend(&mpiRank, 1, MPI_INT, targetRank[i], 0, communicator, &request[indexRequest++]);
+		ep_lib::MPI_Isend(&mpiRank, 1, EP_INT, targetRank[i], 0, communicator, &request[indexRequest]);
+		indexRequest++;
 	}
 	MPI_Waitall(indexRequest, request, status);
@@ -173,15 +174,15 @@
 	for (int i = 0; i < nbSource; i++)
 	{
-		#ifdef _usingEP
-		MPI_Irecv(&sourceRank[i], 1, MPI_INT, -2, 0, communicator, &request[indexRequest]);
-		#else
-		MPI_Irecv(&sourceRank[i], 1, MPI_INT, MPI_ANY_SOURCE, 0, communicator, &request[indexRequest]);
+		#ifdef _usingMPI
+                ep_lib::MPI_Irecv(&sourceRank[i], 1, EP_INT, MPI_ANY_SOURCE, 0, communicator, &request[indexRequest]);
+		#elif _usingEP
+                ep_lib::MPI_Irecv(&sourceRank[i], 1, EP_INT, -2, 0, communicator, &request[indexRequest]);
 		#endif
-		indexRequest++;
-	}
-
-	for (int i = 0; i < nbTarget; i++)
-	{
-		MPI_Isend(&mpiRank, 1, MPI_INT, targetRank[i], 0, communicator, &request[indexRequest]);
+                indexRequest++;
+	}
+
+	for (int i = 0; i < nbTarget; i++)
+	{
+		ep_lib::MPI_Isend(&mpiRank, 1, EP_INT, targetRank[i], 0, communicator, &request[indexRequest]);
 		indexRequest++;
 	}
@@ -208,5 +209,5 @@
 	for (int i = 0; i < nbSource; i++)
 	{
-		MPI_Irecv(&nbSourceElement[i], 1, MPI_INT, sourceRank[i], 0, communicator, &request[indexRequest]);
+		ep_lib::MPI_Irecv(&nbSourceElement[i], 1, EP_INT, sourceRank[i], 0, communicator, &request[indexRequest]);
 		indexRequest++;
 	}
@@ -215,5 +216,5 @@
 	{
 		totalTargetElement += nbTargetElement[i];
-		MPI_Isend(&nbTargetElement[i], 1, MPI_INT, targetRank[i], 0, communicator, &request[indexRequest]);
+		ep_lib::MPI_Isend(&nbTargetElement[i], 1, EP_INT, targetRank[i], 0, communicator, &request[indexRequest]);
 		indexRequest++;
 	}
@@ -283,9 +284,9 @@
 
 
-	MPI_Request* request=new MPI_Request[nbSource+nbTarget];
-	MPI_Status*  status=new MPI_Status[nbSource+nbTarget];
+	ep_lib::MPI_Request* request=new ep_lib::MPI_Request[nbSource+nbTarget];
+	ep_lib::MPI_Status*  status=new ep_lib::MPI_Status[nbSource+nbTarget];
 	int indexRequest=0;
 
-	MPI_Barrier(communicator);
+	ep_lib::MPI_Barrier(communicator);
 	CTimer::get("CMPIRouting::transferToTarget").reset();
 	CTimer::get("CMPIRouting::transferToTarget").resume();
@@ -293,5 +294,5 @@
 	for(int i=0; i<nbSource; i++)
 	{
-		MPI_Irecv(sourceBuffer[i],nbSourceElement[i]*sizeof(T),MPI_CHAR, sourceRank[i], 0, communicator, &request[indexRequest]);
+		ep_lib::MPI_Irecv(sourceBuffer[i],nbSourceElement[i]*sizeof(T),EP_CHAR, sourceRank[i], 0, communicator, &request[indexRequest]);
 		indexRequest++;
 	}
@@ -299,13 +300,13 @@
 	for(int i=0;i<nbTarget; i++)
 	{
-		MPI_Isend(targetBuffer[i],nbTargetElement[i]*sizeof(T), MPI_CHAR, targetRank[i], 0, communicator, &request[indexRequest]);
-		indexRequest++;
-	}
-
-	MPI_Waitall(indexRequest,request,status);
+		ep_lib::MPI_Isend(targetBuffer[i],nbTargetElement[i]*sizeof(T), EP_CHAR, targetRank[i], 0, communicator, &request[indexRequest]);
+		indexRequest++;
+	}
+
+	ep_lib::MPI_Waitall(indexRequest,request,status);
 
 	CTimer::get("CMPIRouting::transferToTarget").suspend();
 	CTimer::get("CMPIRouting::transferToTarget").print();
-	MPI_Barrier(communicator);
+	ep_lib::MPI_Barrier(communicator);
 
 	// unpack the data
@@ -347,9 +348,9 @@
 	}
 
-	MPI_Request *request = new MPI_Request[nbSource + nbTarget];
-	MPI_Status  *status = new MPI_Status[nbSource + nbTarget];
+	ep_lib::MPI_Request *request = new ep_lib::MPI_Request[nbSource + nbTarget];
+	ep_lib::MPI_Status  *status = new ep_lib::MPI_Status[nbSource + nbTarget];
 	int indexRequest = 0;
 
-	MPI_Barrier(communicator);
+	ep_lib::MPI_Barrier(communicator);
 	CTimer::get("CMPIRouting::transferToTarget(messageSize)").reset();
 	CTimer::get("CMPIRouting::transferToTarget(messageSize)").resume();
@@ -357,5 +358,5 @@
 	for(int i=0; i<nbSource; i++)
 	{
-		MPI_Irecv(&sourceMessageSize[i],1,MPI_INT, sourceRank[i], 0, communicator, &request[indexRequest]);
+		ep_lib::MPI_Irecv(&sourceMessageSize[i],1,EP_INT, sourceRank[i], 0, communicator, &request[indexRequest]);
 		indexRequest++;
 	}
@@ -363,11 +364,11 @@
 	for(int i=0; i<nbTarget; i++)
 	{
-		MPI_Isend(&targetMessageSize[i],1, MPI_INT, targetRank[i], 0, communicator, &request[indexRequest]);
-		indexRequest++;
-	}
-
-	MPI_Waitall(indexRequest,request,status);
-
-	MPI_Barrier(communicator);
+		ep_lib::MPI_Isend(&targetMessageSize[i],1, EP_INT, targetRank[i], 0, communicator, &request[indexRequest]);
+		indexRequest++;
+	}
+
+	ep_lib::MPI_Waitall(indexRequest,request,status);
+
+	ep_lib::MPI_Barrier(communicator);
 	CTimer::get("CMPIRouting::transferToTarget(messageSize)").suspend();
 	CTimer::get("CMPIRouting::transferToTarget(messageSize)").print();
@@ -402,5 +403,5 @@
 	for(int i=0; i<nbSource; i++)
 	{
-		MPI_Irecv(sourceBuffer[i],sourceMessageSize[i],MPI_CHAR, sourceRank[i], 0, communicator, &request[indexRequest]);
+		ep_lib::MPI_Irecv(sourceBuffer[i],sourceMessageSize[i],EP_CHAR, sourceRank[i], 0, communicator, &request[indexRequest]);
 		indexRequest++;
 	}
@@ -408,5 +409,5 @@
 	for(int i=0;i<nbTarget; i++)
 	{
-		MPI_Isend(targetBuffer[i],targetMessageSize[i], MPI_CHAR, targetRank[i], 0, communicator, &request[indexRequest]);
+		ep_lib::MPI_Isend(targetBuffer[i],targetMessageSize[i], EP_CHAR, targetRank[i], 0, communicator, &request[indexRequest]);
 		indexRequest++;
 	}
@@ -467,11 +468,11 @@
 	}
 
-	MPI_Request* request=new MPI_Request[nbSource+nbTarget];
-	MPI_Status*  status=new MPI_Status[nbSource+nbTarget];
+	ep_lib::MPI_Request* request=new ep_lib::MPI_Request[nbSource+nbTarget];
+	ep_lib::MPI_Status*  status=new ep_lib::MPI_Status[nbSource+nbTarget];
 	int indexRequest=0;
 
 	for(int i=0; i<nbSource; i++)
 	{
-		MPI_Isend(sourceBuffer[i],nbSourceElement[i]*sizeof(T),MPI_CHAR, sourceRank[i], 0, communicator, &request[indexRequest]);
+		ep_lib::MPI_Isend(sourceBuffer[i],nbSourceElement[i]*sizeof(T),EP_CHAR, sourceRank[i], 0, communicator, &request[indexRequest]);
 		indexRequest++;
 	}
@@ -479,9 +480,9 @@
 	for(int i=0;i<nbTarget; i++)
 	{
-		MPI_Irecv(targetBuffer[i],nbTargetElement[i]*sizeof(T), MPI_CHAR, targetRank[i], 0, communicator, &request[indexRequest]);
-		indexRequest++;
-	}
-
-	MPI_Waitall(indexRequest,request,status);
+		ep_lib::MPI_Irecv(targetBuffer[i],nbTargetElement[i]*sizeof(T), EP_CHAR, targetRank[i], 0, communicator, &request[indexRequest]);
+		indexRequest++;
+	}
+
+	ep_lib::MPI_Waitall(indexRequest,request,status);
 
 	// unpack the data
@@ -523,18 +524,18 @@
 	}
 
-	MPI_Request *request = new MPI_Request[nbSource + nbTarget];
-	MPI_Status  *status = new MPI_Status[nbSource + nbTarget];
+	ep_lib::MPI_Request *request = new ep_lib::MPI_Request[nbSource + nbTarget];
+	ep_lib::MPI_Status  *status = new ep_lib::MPI_Status[nbSource + nbTarget];
 	int indexRequest = 0;
 	for (int i = 0; i < nbSource; i++)
 	{
-		MPI_Isend(&sourceMessageSize[i], 1, MPI_INT, sourceRank[i], 0, communicator, &request[indexRequest]);
-		indexRequest++;
-	}
-	for (int i = 0; i < nbTarget; i++)
-	{
-		MPI_Irecv(&targetMessageSize[i], 1, MPI_INT, targetRank[i], 0, communicator, &request[indexRequest]);
-		indexRequest++;
-	}
-	MPI_Waitall(indexRequest, request, status);
+		ep_lib::MPI_Isend(&sourceMessageSize[i], 1, EP_INT, sourceRank[i], 0, communicator, &request[indexRequest]);
+		indexRequest++;
+	}
+	for (int i = 0; i < nbTarget; i++)
+	{
+		ep_lib::MPI_Irecv(&targetMessageSize[i], 1, EP_INT, targetRank[i], 0, communicator, &request[indexRequest]);
+		indexRequest++;
+	}
+	ep_lib::MPI_Waitall(indexRequest, request, status);
 
 	for (int i = 0; i < nbTarget; i++)
@@ -564,13 +565,13 @@
 	for (int i = 0; i < nbSource; i++)
 	{
-		MPI_Isend(sourceBuffer[i], sourceMessageSize[i], MPI_CHAR, sourceRank[i], 0, communicator, &request[indexRequest]);
-		indexRequest++;
-	}
-	for (int i = 0; i < nbTarget; i++)
-	{
-		MPI_Irecv(targetBuffer[i], targetMessageSize[i], MPI_CHAR, targetRank[i], 0, communicator, &request[indexRequest]);
-		indexRequest++;
-	}
-	MPI_Waitall(indexRequest, request, status);
+		ep_lib::MPI_Isend(sourceBuffer[i], sourceMessageSize[i], EP_CHAR, sourceRank[i], 0, communicator, &request[indexRequest]);
+		indexRequest++;
+	}
+	for (int i = 0; i < nbTarget; i++)
+	{
+		ep_lib::MPI_Irecv(targetBuffer[i], targetMessageSize[i], EP_CHAR, targetRank[i], 0, communicator, &request[indexRequest]);
+		indexRequest++;
+	}
+	ep_lib::MPI_Waitall(indexRequest, request, status);
 
 	// unpack the data
@@ -612,8 +613,8 @@
 
 template void alltoalls_unknown(const std::vector<std::vector<NES> >& send, std::vector<std::vector<NES> >& recv,
-                                const std::vector<int>& ranks, MPI_Comm communicator);
+                                const std::vector<int>& ranks, ep_lib::MPI_Comm communicator);
 
 template void alltoalls_known(const std::vector<std::vector<int> >& send, std::vector<std::vector<int> >& recv,
-                              const std::vector<int>& ranks, MPI_Comm communicator);
-
-}
+                              const std::vector<int>& ranks, ep_lib::MPI_Comm communicator);
+
+}
Index: XIOS/dev/branch_openmp/extern/remap/src/parallel_tree.cpp
===================================================================
--- XIOS/dev/branch_openmp/extern/remap/src/parallel_tree.cpp	(revision 1545)
+++ XIOS/dev/branch_openmp/extern/remap/src/parallel_tree.cpp	(revision 1642)
@@ -12,13 +12,6 @@
 
 #include "parallel_tree.hpp"
-using namespace ep_lib;
 
 namespace sphereRemap {
-
-extern CRemapGrid srcGrid;
-#pragma omp threadprivate(srcGrid)
-
-extern CRemapGrid tgtGrid;
-#pragma omp threadprivate(tgtGrid)
 
 static const int assignLevel = 2;
@@ -121,9 +114,10 @@
 }
 
-CParallelTree::CParallelTree(MPI_Comm comm) : communicator(comm), cascade(MIN_NODE_SZ*MIN_NODE_SZ*2, comm)
-{
-  treeCascade.reserve(cascade.num_levels);
-  for (int lev = 0; lev < cascade.num_levels; lev++)
-    treeCascade.push_back(CSampleTree(cascade.level[lev].group_size, assignLevel));
+//CParallelTree::CParallelTree(MPI_Comm comm) : communicator(comm), cascade(MIN_NODE_SZ*MIN_NODE_SZ, comm)
+CParallelTree::CParallelTree(ep_lib::MPI_Comm comm) : communicator(comm), cascade(MAX_NODE_SZ*MAX_NODE_SZ*2, comm)
+{
+	treeCascade.reserve(cascade.num_levels);
+	for (int lev = 0; lev < cascade.num_levels; lev++)
+		treeCascade.push_back(CSampleTree(cascade.level[lev].group_size, assignLevel));
 }
 
@@ -157,6 +151,5 @@
 
 	int nrecv; // global number of samples  THIS WILL BE THE NUMBER OF LEAFS IN THE SAMPLE TREE
-	MPI_Allreduce(&n, &nrecv, 1, MPI_INT, MPI_SUM, comm.comm); // => size of sample tree does not depend on keepNodes!
-
+	ep_lib::MPI_Allreduce(&n, &nrecv, 1, EP_INT, EP_SUM, comm.comm); // => size of sample tree does not depend on keepNodes!
 	double ratio = blocSize / (1.0 * nrecv);
 	int nsend = ratio * n + 1; // nsend = n_local_samples / n_global_samples * blocksize + 1 = blocksize/comm.size
@@ -164,5 +157,5 @@
 
 	int *counts = new int[comm.size];
-	MPI_Allgather(&nsend, 1, MPI_INT, counts, 1, MPI_INT, comm.comm);
+	ep_lib::MPI_Allgather(&nsend, 1, EP_INT, counts, 1, EP_INT, comm.comm);
 
 	nrecv = 0;
@@ -190,5 +183,5 @@
 	/* each process needs the sample elements from all processes */
 	double *recvBuffer = new double[nrecv*4];
-	MPI_Allgatherv(sendBuffer, 4 * nsend, MPI_DOUBLE, recvBuffer, counts, displs, MPI_DOUBLE, comm.comm);
+	ep_lib::MPI_Allgatherv(sendBuffer, 4 * nsend, EP_DOUBLE, recvBuffer, counts, displs, EP_DOUBLE, comm.comm);
 	delete[] sendBuffer;
 	delete[] counts;
@@ -248,5 +241,5 @@
          << "   node size : "<<node.size()<<"   bloc size : "<<blocSize<<"  total number of leaf : "<<tree.leafs.size()<<endl ;
 /*
-	MPI_Allreduce(&ok, &allok, 1, MPI_INT, MPI_PROD, communicator);
+	MPI_Allreduce(&ok, &allok, 1, EP_INT, MPI_PROD, communicator);
 	if (!allok) {
 		MPI_Finalize();
@@ -254,5 +247,5 @@
 	}
 */
-    MPI_Abort(MPI_COMM_WORLD,-1) ;
+    ep_lib::MPI_Abort(EP_COMM_WORLD,-1) ;
   }
 /*
@@ -272,5 +265,5 @@
 {
 	CMPIRouting MPIRoute(communicator);
-	MPI_Barrier(communicator);
+	ep_lib::MPI_Barrier(communicator);
 	CTimer::get("buildLocalTree(initRoute)").resume();
 	MPIRoute.init(route);
@@ -297,5 +290,5 @@
 
 	int mpiRank;
-	MPI_Comm_rank(communicator, &mpiRank);
+	ep_lib::MPI_Comm_rank(communicator, &mpiRank);
 	localTree.leafs.reserve(nbLocalElements);
 	for (int i = 0; i < nbLocalElements; i++)
@@ -323,7 +316,7 @@
   nb1=node.size() ; nb2=node2.size() ;
   nb=nb1+nb2 ;
-  MPI_Allreduce(&nb, &nbTot, 1, MPI_LONG, MPI_SUM, communicator) ;
+  ep_lib::MPI_Allreduce(&nb, &nbTot, 1, EP_LONG, EP_SUM, communicator) ;
   int commSize ;
-  MPI_Comm_size(communicator,&commSize) ;
+  ep_lib::MPI_Comm_size(communicator,&commSize) ;
   
 	// make multiple of two
@@ -508,9 +501,9 @@
 	// gather circles on this level of the cascade
 	int pg_size;
-	MPI_Comm_size(cascade.level[level].pg_comm, &pg_size);
+	ep_lib::MPI_Comm_size(cascade.level[level].pg_comm, &pg_size);
 	vector<Coord> allRootCentres(pg_size);
 	vector<double> allRootRadia(pg_size);
-	MPI_Allgather(&rootCentre, 3, MPI_DOUBLE, &allRootCentres[0], 3, MPI_DOUBLE, cascade.level[level].pg_comm);
-	MPI_Allgather(&rootRadius, 1, MPI_DOUBLE, &allRootRadia[0],   1, MPI_DOUBLE, cascade.level[level].pg_comm);
+	ep_lib::MPI_Allgather(&rootCentre, 3, EP_DOUBLE, &allRootCentres[0], 3, EP_DOUBLE, cascade.level[level].pg_comm);
+	ep_lib::MPI_Allgather(&rootRadius, 1, EP_DOUBLE, &allRootRadia[0],   1, EP_DOUBLE, cascade.level[level].pg_comm);
 
 	// now allRootsRadia and allRootCentres must be inserted into second levels of us and propagated to root
